Bug 1792065 - python-deap fails to build with Python 3.9: imports abc from collections
Summary: python-deap fails to build with Python 3.9: imports abc from collections
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: python-deap
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Aniket Pradhan
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: PYTHON39
TreeView+ depends on / blocked
 
Reported: 2020-01-16 23:17 UTC by Miro Hrončok
Modified: 2020-03-01 23:19 UTC (History)
7 users (show)

Fixed In Version: python-deap-1.3.1-1.fc31 python-deap-1.3.1-1.fc30
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2020-02-28 09:07:33 UTC
Type: Bug


Attachments (Terms of Use)

Description Miro Hrončok 2020-01-16 23:17:12 UTC
python-deap fails to build with Python 3.9.0a2.

Traceback (most recent call last):
  File "/usr/lib/python3.9/site-packages/nose/failure.py", line 39, in runTest
    raise self.exc_val.with_traceback(self.tb)
  File "/usr/lib/python3.9/site-packages/nose/loader.py", line 416, in loadTestsFromName
    module = self.importer.importFromPath(
  File "/usr/lib/python3.9/site-packages/nose/importer.py", line 47, in importFromPath
    return self.importFromDir(dir_path, fqname)
  File "/usr/lib/python3.9/site-packages/nose/importer.py", line 94, in importFromDir
    mod = load_module(part_fqname, fh, filename, desc)
  File "/usr/lib64/python3.9/imp.py", line 234, in load_module
    return load_source(name, filename, file)
  File "/usr/lib64/python3.9/imp.py", line 171, in load_source
    module = _load(spec)
  File "<frozen importlib._bootstrap>", line 702, in _load
  File "<frozen importlib._bootstrap>", line 671, in _load_unlocked
  File "<frozen importlib._bootstrap_external>", line 786, in exec_module
  File "<frozen importlib._bootstrap>", line 219, in _call_with_frames_removed
  File "/builddir/build/BUILD/deap-1.3.0/build/lib.linux-x86_64-3.9/deap/tests/test_pickle.py", line 12, in <module>
    from deap import base
  File "/builddir/build/BUILD/deap-1.3.0/build/lib.linux-x86_64-3.9/deap/base.py", line 23, in <module>
    from collections import Sequence
ImportError: cannot import name 'Sequence' from 'collections' (/usr/lib64/python3.9/collections/__init__.py)


See https://docs.python.org/3.9/whatsnew/3.9.html#removed

"The abstract base classes in collections.abc no longer are exposed in the regular collections module. This will help create a clearer distinction between the concrete classes and the abstract base classes."


For the build logs, see:
https://copr-be.cloud.fedoraproject.org/results/@python/python3.9/fedora-rawhide-x86_64/01148901-python-deap/

For all our attempts to build python-deap with Python 3.9, see:
https://copr.fedorainfracloud.org/coprs/g/python/python3.9/package/python-deap/

Testing and mass rebuild of packages is happening in copr. You can follow these instructions to test locally in mock if your package builds with Python 3.9:
https://copr.fedorainfracloud.org/coprs/g/python/python3.9/

Let us know here if you have any questions.

Python 3.9 will be included in Fedora 33. To make that update smoother, we're building Fedora packages with early pre-releases of Python 3.9.
A build failure prevents us from testing all dependent packages (transitive [Build]Requires), so if this package is required a lot, it's important for us to get it fixed soon.
We'd appreciate help from the people who know this package best, but if you don't want to work on this now, let us know so we can try to work around it on our side.

Comment 1 Hugo van Kemenade 2020-01-20 15:12:18 UTC
This has been fixed in master (https://github.com/DEAP/deap/pull/406, Sept 2019) but not in the last release (1.3.0, June 2019).

I've asked about a new release in the PR.

Comment 2 Hugo van Kemenade 2020-01-21 07:28:14 UTC
This has now been released in DEAP 1.3.1: https://pypi.org/project/deap/1.3.1/

Please update!

Comment 3 Ben Cotton 2020-02-11 17:31:40 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 32 development cycle.
Changing version to 32.

Comment 4 Fedora Update System 2020-02-22 12:50:43 UTC
FEDORA-2020-9bf5331afb has been submitted as an update to Fedora 31. https://bodhi.fedoraproject.org/updates/FEDORA-2020-9bf5331afb

Comment 5 Fedora Update System 2020-02-23 01:56:34 UTC
python-deap-1.3.1-1.fc30 has been pushed to the Fedora 30 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2020-ca3ea14b98

Comment 6 Fedora Update System 2020-02-23 02:18:04 UTC
python-deap-1.3.1-1.fc31 has been pushed to the Fedora 31 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2020-9bf5331afb

Comment 7 Miro Hrončok 2020-02-28 09:07:33 UTC
In Python 3.9.0a4 we have managed to revert the change that disables importing abstract base classes (collections.abc) directly form the regular collections module. It was reverted to ease transition for projects that did not yet actually dropped support for Python 2.7. The removal is scheduled for Python 3.10 instead.

We are mass closing all the bug reports about build failures that were caused by this. Expect a new Bugzilla report in case this package fails to build with Python 3.9 for a different reason as well.

In case you haven't done this already, we highly recommend to talk to your upstream and get this fixed anyway, because this will return in Python 3.10 and Python upstream is very unlikely to postpone this once more. In case you've already done that, thank you (this message is mass posted to all the relevant Bugzillas).

Comment 8 Fedora Update System 2020-03-01 22:25:10 UTC
python-deap-1.3.1-1.fc31 has been pushed to the Fedora 31 stable repository. If problems still persist, please make note of it in this bug report.

Comment 9 Fedora Update System 2020-03-01 23:19:45 UTC
python-deap-1.3.1-1.fc30 has been pushed to the Fedora 30 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.